'''
Gatimaan- FOSS Youtube Video Downloader Built In Kivy and Python.
                 Copyright (C) 2023-24
                     Sameer Sharma

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see https://www.gnu.org/licenses/.
'''

import kivy
kivy.require("1.11.0")
from kivy.config import Config
Config.set('input', 'mouse', 'mouse,multitouch_on_demand')
Config.set('kivy', 'log_level', 'warning')
from platformdirs import *
from kivy.app import App
from kivy.uix.screenmanager import ScreenManager, Screen
from kivy.core.audio import SoundLoader
from kivy.properties import ObjectProperty
from kivy.core.window import Window
import threading
import subprocess
import webbrowser
import validators
import os
import os.path
import time

class MainScreen(Screen):
    link= ObjectProperty(None)
    dbutton= ObjectProperty()
    abutton= ObjectProperty()
    mbutton=ObjectProperty()
    dlbutton=ObjectProperty()

    def clear(self):
        self.link.text= ""

    def athread(self):
        threading.Thread(target=self.about).start()

    def about(self):
        webbrowser.open('https://launchpad.net/gatimaan')

    def dlthread(self):
        threading.Thread(target=self.downloads).start()

    def downloads(self):
        downloads= user_downloads_path()
        path= f"{downloads}/Gatimaan"
        check= os.path.exists(path)
        if os.path.exists(path) and not os.path.isfile(path):
            confirm= not os.listdir(path)
        if check==True and confirm==False:
            cmd=f"xdg-open {path}"
            subprocess.call(cmd, shell=True)
        else:
            self.ids.title.text= "No Downloads Yet !"
            sound = SoundLoader.load('audio/arabian.wav')
            if sound:
                sound.play()
            dnotify= "notify-send -t 7500 --app-name='Gatimaan' 'No Downloads Yet ! 😛'"
            subprocess.call(dnotify, shell=True)
            time.sleep(2)
            self.ids.title.text= "Gatimaan Video Downloader"

    def vthread(self):
        link = self.link.text
        threading.Thread(target=self.video, args=(link,)).start()

    def video(self, link):
        if link!="":
            valid=validators.url(link)
            if valid==True:
                downloads=user_downloads_path()
                cmd= f"yt-dlp -f 'bv*+ba' {link} -o '{downloads}/Gatimaan/%(title)s.%(ext)s'"
                dnotify= "notify-send -t 8800 --app-name='Gatimaan' 'Downloading Video 😎 !'"
                sound = SoundLoader.load('audio/interface-start.wav')
                if sound:
                    sound.play()
                subprocess.call(dnotify, shell=True)
                self.ids.title.text= "Downloading Video"
                subprocess.call(cmd, shell=True)
                time.sleep(2)
                soundx = SoundLoader.load('audio/interface-remove.wav')
                if soundx:
                    soundx.play()
                dnotifyx= "notify-send -t 7500 --app-name='Gatimaan' 'Downloaded Video 🎉🎊 !'"
                subprocess.call(dnotifyx, shell=True)
                self.ids.title.text= "Gatimaan Video Downloader"
                
            else:
                sound = SoundLoader.load('audio/arabian.wav')
                if sound:
                    sound.play()
                dnotify= "notify-send -t 7500 --app-name='Gatimaan' 'Invalid URL, Enter Valid URL 🙃'"
                subprocess.call(dnotify, shell=True)
                self.ids.title.text= "Invalid URL, Enter Valid URL"
                time.sleep(1.4)
                self.ids.title.text= "Gatimaan Video Downloader"
                
        else:
            self.ids.title.text= "Enter Media Link"
            time.sleep(1.1)
            self.ids.title.text= "Gatimaan Video Downloader"

    def mthread(self):
        link=self.link.text
        threading.Thread(target=self.music, args=(link,)).start()

    def music(self,link):
        if link!="":
            valid=validators.url(link)
            if valid==True:
                downloads=user_downloads_path()
                cmd= f"yt-dlp -f 'ba' -x --audio-format mp3 {link} -o '{downloads}/Gatimaan/%(title)s.%(ext)s' --embed-thumbnail --add-metadata --metadata-from-title '%(artist)s - %(title)s'"
                dnotify= "notify-send -t 8800 --app-name='Gatimaan' 'Downloading MP3/Audio File 😎 !'"
                sound = SoundLoader.load('audio/interface-start.wav')
                if sound:
                    sound.play()
                subprocess.call(dnotify, shell=True)
                self.ids.title.text= "Downloading Audio"
                subprocess.call(cmd, shell=True)
                time.sleep(2)
                soundx = SoundLoader.load('audio/interface-remove.wav')
                if soundx:
                    soundx.play()
                dnotifyx= "notify-send -t 7500 --app-name='Gatimaan' 'Downloaded MP3/Audio File 🎉🎊 !'"
                subprocess.call(dnotifyx, shell=True)
                self.ids.title.text= "Gatimaan Video Downloader"
                
            else:
                sound = SoundLoader.load('audio/arabian.wav')
                if sound:
                    sound.play()
                dnotify= "notify-send -t 7500 --app-name='Gatimaan' 'Invalid URL, Enter Valid URL 🙃'"
                subprocess.call(dnotify, shell=True)
                self.ids.title.text= "Invalid URL, Enter Valid URL"
                time.sleep(1.4)
                self.ids.title.text= "Gatimaan Video Downloader"
                            
        else:
            self.ids.title.text= "Enter Media Link"
            time.sleep(1.1)
            self.ids.title.text= "Gatimaan Video Downloader"
            
class SecondScreen(Screen):
    pass

class WindowManager(ScreenManager):
    pass

class Gatimaan(App):
    icon = 'packaging/gatimaan.png'
    title = 'Gatimaan'
    def build(self):
        sm=ScreenManager()
        sm.add_widget(MainScreen(name='main'))
        sm.add_widget(SecondScreen(name='second'))
        return sm

if __name__=='__main__':
    Gatimaan().run()
    Window.close()